package eGuideDog::Terminal;

use strict;
use Curses;
use Time::HiRes;
use eGuideDog::Terminal::Buffer;
use threads;

sub new {
  my $self = {};

  initscr();
#  keypad(1);
  noecho();
#  raw();
  halfdelay(1);
  $SIG{INT} = 'IGNORE';

  bless $self, __PACKAGE__;
  return $self;
}

sub DESTROY {
  endwin();
}

#sub new_buffer {
#  my ($self, $id, $buffer) = @_;

#  my $buf = eGuideDog::Terminal::Buffer->new($id, $buffer);
#  $self->{buffers}->{$id} = $buf;
#  $self->{current_buffer} = $buf;
#  $self->refresh();
#  return $buf;
#}

sub print_buffer {
  my ($self, $buffer) = @_;

  if (not $buffer->update) {
    return;
  }
  $buffer->update(0);

  clear;
  move(0, 0);

  if ($buffer->{head} > $buffer->{index}) {
    $buffer->{head} = $buffer->{index};
  }

  my $line = 0;
  my $i;
  for($i = $buffer->{head}; $i < $buffer->{lines} && $line < LINES; $i++) {
    if ($i == $buffer->{index}) {
      attron(A_BOLD); # turn on highlighting
      addstr($buffer->{lines}->[$i]);
      attroff(A_BOLD);
    } else {
      addstr($buffer->{lines}->[$i]);
    }
    my $len = length($buffer->{lines}->[$i]);
    while ($len > COLS) {
      $len -= COLS;
      $line++;
    }
    $line++;
    move($line, 0);
  }

  if ($i <= $buffer->{index}) {
    $buffer->{head} = $buffer->{index};
    $buffer->update(1);
    $self->print_buffer($buffer);
  }
}

sub readkey {
  my $key = getch();
#  if ($key eq '-1') {
#    sleep(0.1);
#    $key = getch();
#  }
  my $char;
  if ($key eq "\x{1B}") { # ALT +
    $char = getch();
    $key .= $char;
    if ($char eq "\x{5B}") { # UP/DOWN/LEFT/RIGHT
      $char = getch();
      $key .= $char;
      if ($char eq "\x{35}" || $char eq "\x{36}") { # PAGE UP/DOWN
	$key .= getch();
      }
    }
  }
#  warn $key if ($key ne '-1');
  return $key;
}

1;
